/* Nonull  - returns an empty string if a null value passed in parameter 1  */
declare external function   Nonull
 cstring(1024)
 returns cstring(1024) FREE_IT
 entry_point 'Nonull' module_name 'udf_file.dll';




/* File_Write  - writes the string in parameter 1 to the external file in parameter 2 */
declare external function   File_write
 cstring(1024),cstring(1024)
 returns integer by value
 entry_point 'File_write' module_name 'udf_file.dll';

/* File_Writeln  - writes the string in parameter 1  adding crlf to the external file in parameter 2 */

declare external function   File_writeln
cstring(1024),cstring(1024)
 returns integer by value
 entry_point 'File_writeln' module_name 'udf_file.dll';

/* File_delete - deletes the external file in parameter 1 */

declare external function   File_delete
 cstring(1024)
 returns integer by value
 entry_point 'File_delete' module_name 'udf_file.dll';

/* File_create - creates, or empties the external file in parameter 1 */

declare external function   File_create
cstring(1024)
 returns integer by value
 entry_point 'File_create' module_name 'udf_file.dll';

/* Strformat - formats the string parameter 1, using parameter 3 separted list of strings in parameter 2 */

declare external function   Strformat
cstring(1024),cstring(1024),cstring(1)
 returns Cstring(1024) FREE_IT
 entry_point 'Strformat' module_name 'udf_file.dll';

/* File_rename - renames the external file in parameter 1  to parameter 2*/

declare external function   File_rename
cstring(1024),cstring(1024)
 returns integer by value
 entry_point 'File_rename' module_name 'udf_file.dll';

/* File_concat - appends all the files in the comma separated list in  parameter 1 to the file named in parameter 2*/

declare external function   File_concat
cstring(1024),cstring(124)
 returns integer by value
 entry_point 'File_concat' module_name 'udf_file.dll';


/*Padleft  - pads left the parameter 1 with parameter 2 number of spaces */

declare external function   Padleft
cstring(1024),integer
 returns cstring(1024) FREE_IT
 entry_point 'Padleft' module_name 'udf_file.dll';

/*Padright  - pads right the parameter 1 with parameter 2 number of spaces */

declare external function  Padright
cstring(1024),integer
 returns cstring(1024) FREE_IT

 entry_point 'Padright' module_name 'udf_file.dll';

/*Squotedstr  - returns a string surrounded by single quotes */

declare external function  Squotedstr
cstring(1024)
 returns cstring(1024) FREE_IT
 entry_point 'Squotedstr' module_name 'udf_file.dll';

/*dquotedstr  - returns a string surrounded by single quotes */

declare external function  dquotedstr
cstring(1024)
 returns cstring(1024) FREE_IT
 entry_point 'Dquotedstr' module_name 'udf_file.dll';

/*datetimeformat  - Formats the date in paramater 2 according to the mask in parameter 1 */

declare external function  Datetimeformat
cstring(1024),timestamp
 returns cstring(1024) FREE_IT
 entry_point 'Datetimeformat' module_name 'udf_file.dll';

/*datetimeformat  - Formats the date in paramater 2 according to the mask in parameter 1 */

declare external function  Numberformat
cstring(1024),cstring(1024)
 returns cstring(1024) FREE_IT
 entry_point 'Numberformat' module_name 'udf_file.dll';




/* Stored Procedures using the Above functions */


Set term ^;

Create procedure Fileconcat(sourcefiles varchar(1024),destfile varchar(255)) returns (res integer)
as
begin
   res=file_concat(sourcefiles,destfile);
   suspend;
end^

Create procedure Filedelete(filename  varchar(255)) returns (res integer)
as
begin
   res=file_delete(filename);
   suspend;
end^

Create procedure Filecreate(filename  varchar(255)) returns (res integer)
as
begin
   res=file_create(filename);
   suspend;
end^

Create procedure Filerename(oldfilename varchar(255),newfilename varchar(255)) returns (res integer)
as
begin
   res=file_rename(oldfilename,newfilename);
   suspend;
end^

set term ;^



/* example use of functions to Dump some system info to HTML File */

COMMIT WORK;
SET AUTODDL OFF;
SET TERM ^ ;

/* Stored procedures */

CREATE PROCEDURE DUMP_ASHTML 
(
  AFILENAME VARCHAR(255)
)
RETURNS
(
  RES INTEGER
)
AS
BEGIN EXIT; END ^


ALTER PROCEDURE DUMP_ASHTML 
(
  AFILENAME VARCHAR(255)
)
RETURNS
(
  RES INTEGER
)
AS
declare variable pinputs integer;
declare variable poutputs integer;
declare variable pname varchar(32);
begin
  res=file_create(afilename);
  if (res<>0) then
   begin
     suspend;
     exit;
   end
  res=file_writeln(afilename,'<h1>Tables and Views</h1><br><TABLE border=1><TR><th>Table Name</th></TR>');
  if (res<>0) then
   begin
     suspend;
     exit;
   end
 for
  select  Rdb$RElation_name from rdb$relations where rdb$system_flag=0 order by Rdb$RElation_name into :pname do
      begin
       res=file_writeln(afilename,'<TR><td>'||nonull(pname)||'</td><td>');
       if (res<>0) then
        begin
          suspend;
          exit;
        end
       end
  res=file_writeln(afilename,'</TABLE>');
/* Procedures */
  res=file_writeln(afilename,'<h1>Stored Procedures</h1><br><TABLE border=1> <TR><th>Procedure Name</th><th>Inputs</th><th>Outputs</th></TR>');
  if (res<>0) then
   begin
     suspend;
     exit;
   end
for
 select rdb$Procedure_name ,rdb$procedure_inputs,rdb$procedure_outputs from rdb$Procedures
   order by   rdb$Procedure_name into pname,pinputs,poutputs
   do
   begin
    res=file_writeln(afilename,strformat('<TR><td>% </td><td align="right">% </td><td align="right">% </td></TR>',nonull(pname)||','||nonull(pinputs)||','||nonull(poutputs)||' ',','));
    if (res<>0) then
    begin
     suspend;
     exit;
    end
  end
  res=file_writeln(afilename,'</TABLE>');
  suspend;
end
 ^

SET TERM ; ^
COMMIT WORK;
SET AUTODDL ON;
